nRF51 SDK: Device Firmware Update API.

| nRF51 SDK

- Home
- Related Pages
- API Reference
- Data Structures

All Data Structures Functions Variables Typedefs Enumerations Enumerator Groups Pages
Modules | Typedefs | Functions
Device Firmware Update API.
Bootloader/DFU API

Device Firmware Update module interface. More...

## Modules

| Types and definitions.
| Device Firmware Update module type and definitions.

## Typedefs

typedef void(* | dfu_callback_t )(uint32_t result, uint8_t *p_data)
| DFU event callback for asynchronous calls. More...

## Functions

uint32_t | dfu_init (void)
| Function for initializing the Device Firmware Update module. More...
void | dfu_register_callback (dfu_callback_t callback_handler)
| Function for registering a callback listener for dfu_data_pkt_handle callbacks.
uint32_t | dfu_image_size_set (uint32_t image_size)
| Function for setting the DFU image size. More...
uint32_t | dfu_data_pkt_handle (dfu_update_packet_t *p_packet)
| Function for handling DFU data packets. More...
uint32_t | dfu_init_pkt_handle (dfu_update_packet_t *p_packet)
| Function for handling DFU init packets. More...
uint32_t | dfu_image_validate (void)
| Function for validating a transferred image after the transfer has completed. More...
uint32_t | dfu_image_activate (void)
| Function for activating the transfered image after validation has successfully completed. More...
void | dfu_reset (void)
| Function for reseting the current update procedure and return to initial state. More...

## Detailed Description

Device Firmware Update module interface.

## Typedef Documentation

typedef void(* dfu_callback_t)(uint32_t result, uint8_t *p_data)

DFU event callback for asynchronous calls.

Parameters

  [in] | result | Operation result code. NRF_SUCCESS when a queued operation was successful.
  [in] | p_data | Pointer to the data to which the operation is related.

## Function Documentation

uint32_t dfu_data_pkt_handle | ( | dfu_update_packet_t * | p_packet | ) |

Function for handling DFU data packets.

Parameters

  [in] | p_packet | Pointer to the DFU packet.

Returns
  NRF_SUCCESS on success, an error_code otherwise.

uint32_t dfu_image_activate | ( | void |  | ) |

Function for activating the transfered image after validation has successfully completed.

Returns
  NRF_SUCCESS on success, an error_code otherwise.

uint32_t dfu_image_size_set | ( | uint32_t | image_size | ) |

Function for setting the DFU image size.

Function sets the DFU image size. This function must be called when an update is started in order to notify the DFU of the new image size.

Parameters

  [in] | image_size | Size of the image to be transmitted.

Returns
  NRF_SUCCESS on success, an error_code otherwise.

uint32_t dfu_image_validate | ( | void |  | ) |

Function for validating a transferred image after the transfer has completed.

Returns
  NRF_SUCCESS on success, an error_code otherwise.

uint32_t dfu_init | ( | void |  | ) |

Function for initializing the Device Firmware Update module.

Returns
  NRF_SUCCESS on success, an error_code otherwise.

uint32_t dfu_init_pkt_handle | ( | dfu_update_packet_t * | p_packet | ) |

Function for handling DFU init packets.

Returns
  NRF_SUCCESS on success, an error_code otherwise.

void dfu_reset | ( | void |  | ) |

Function for reseting the current update procedure and return to initial state.

This function call will result in a system reset to ensure correct system behavior. The reset will might be scheduled to execute at a later point in time to ensure pending flash operations has completed.